<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>
      <v-row
        v-for="(p, index) in entries"
        :key="index"
        dense
      >
        <v-col cols="12">
          <v-row align="center" dense>
            <v-col cols="1">
              <v-img 
                max-width="30px" 
                contain 
                :src="p.logo"
              ></v-img>
            </v-col>
            <v-col cols="3" >
              <div class="esy-label">VM image</div> {{p.image.name}}
            </v-col>
            <v-col cols="3" >
              <div class="esy-label">Platform</div> {{p.platform}}
            </v-col>
            <v-col cols="5">
              <div class="esy-label">Flavours</div>
              <v-chip
                :key="flavour.flavour"
                v-for="(flavour) in p.flavours"
                class="ma-1"
                label
                small
              >
              {{flavour.flavour}}
              </v-chip>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
   </v-container>

</template>

<script>

var keyAndValues = [
  {key: "debian", platform:"debian", vm_user:"debian", img:"https://upload.wikimedia.org/wikipedia/commons/thumb/6/66/Openlogo-debianV2.svg/1200px-Openlogo-debianV2.svg.png"},
  {key: "centos", platform:"centos", vm_user:"centos", img:"https://upload.wikimedia.org/wikipedia/commons/thumb/6/63/CentOS_color_logo.svg/256px-CentOS_color_logo.svg.png"},
  {key: "windows", platform:"windows", vm_user:"asdf", img:"https://upload.wikimedia.org/wikipedia/commons/0/0a/Unofficial_Windows_logo_variant_-_2002%E2%80%932012_%28Multicolored%29.svg"},
  {key: "ubuntu", platform:"ubuntu", vm_user:"ubuntu", img:"https://upload.wikimedia.org/wikipedia/commons/thumb/a/ab/Logo-ubuntu_cof-orange-hex.svg/285px-Logo-ubuntu_cof-orange-hex.svg.png"},
  {key: "linux", platform:"linux", vm_user:"root", img:"https://upload.wikimedia.org/wikipedia/commons/a/af/Tux.png"},
  {key: "", platform:"", vm_user:"", img:"https://upload.wikimedia.org/wikipedia/commons/d/d2/Question_mark.svg"}  
];

export default {

  name: 'BenchmarkedResourcesViewer',

  props: {
    entries: {
      type: Array,
      default: function() {return []}
    },
  },

  data: () => ({
  }),
  
  mounted () {
  },
  
  watch: {
    entries: {
      deep: false,
      handler: function() {
        this.setLogos();
      }
    },
  },
  
  methods: {
  
    setLogos: function() {
      for(var i in this.entries) {
        var entry = this.entries[i];
        var values = this.guessValues(entry.image.name);
        if(values) {
          entry.logo = values.img;
        }
      }
    },

    guessValues: function(imageName) {
      for(var i in keyAndValues) {
        var o = keyAndValues[i];
        if(imageName.toLowerCase().indexOf(o.key)!=-1) {
          return o;
        }
      }
      return null
    }

    
  }

};

</script>
  
<style>
</style>